/*
(C) 1.4.2011  Petr Lastovicka
*/
#include <windows.h>

HANDLE hOutput,hInput;

void initConsole()
{
  hOutput = GetStdHandle(STD_OUTPUT_HANDLE);
  hInput = GetStdHandle(STD_INPUT_HANDLE);
  COORD size = {80, 25};
  SetConsoleScreenBufferSize(hOutput, size);
  SMALL_RECT rc = {0,0, short(size.X-1), short(size.Y-1)};
  SetConsoleWindowInfo(hOutput, TRUE, &rc);
  SetConsoleMode(hOutput, ENABLE_PROCESSED_OUTPUT);
  SetConsoleOutputCP(852);
}

void gotoxy(int x, int y) 
{ 
  COORD pos = { short(x-1), short(y-1) }; 
  SetConsoleCursorPosition(hOutput, pos);
}

void clrscr()
{
  DWORD dw, dwNumCells;
  COORD pos = {0,0};
  CONSOLE_SCREEN_BUFFER_INFO info;

  GetConsoleScreenBufferInfo(hOutput, &info);
  FillConsoleOutputCharacter(hOutput, ' ', dwNumCells = info.dwSize.Y * info.dwSize.X, pos, &dw);
  FillConsoleOutputAttribute(hOutput, info.wAttributes, dwNumCells, pos, &dw);
  gotoxy(1, 1);
}

#define _NOCURSOR 0

void _setcursortype(int t)
{
  CONSOLE_CURSOR_INFO c = {1, t==_NOCURSOR ? FALSE : TRUE};
  SetConsoleCursorInfo(hOutput, &c);
}

void delay(int ms)
{
  Sleep(ms);
}
